"""
Auto generated by Mercado Radar SDK Generator
2025-02-28 16:58:47
"""
from typing import Optional

from ..models._brand import Brand as BrandSchema
from ..models._paginated_response import PaginatedResponse


class Brand:

    def __init__(self, client):
        self.client = client

    def list(self, value: Optional[str] = None, name: Optional[str] = None, limit: Optional[int] = None,
             offset: Optional[int] = None) -> PaginatedResponse[BrandSchema]:
        """
        List all Brands

        List all Brands
        """
        data = {
            "value": value,
            "name": name,
            "limit": limit,
            "offset": offset,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.get(url=f"/v3/brand/", params=data)

        response.raise_for_status()

        data = response.json()

        count = data.get('count', 0)
        next_page = data.get('next')
        previous_page = data.get('previous')
        results = data.get('results')

        parsed_results = []
        for result in results:
            parsed_results.append(BrandSchema(**result))

        parsed_paginated_response = {"count": count, "next": next_page, "previous": previous_page,
                                     "results": parsed_results}

        return PaginatedResponse(**parsed_paginated_response)

    def create(self, value: str, name: str) -> BrandSchema:
        """
        Create a new Brand

        Create a new Brand
        """
        data = {
            "value": value,
            "name": name,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.post(url=f"/v3/brand/", json=data)

        response.raise_for_status()

        return BrandSchema(**response.json())

    def retrieve(self, id: Optional[int] = None) -> BrandSchema:
        """
        Retrieve a Brand by ID

        Retrieve a Brand by ID
        """

        response = self.client.get(url=f"/v3/brand/{id}/")

        response.raise_for_status()

        return BrandSchema(**response.json())

    def update(self, value: str, name: str, id: Optional[int] = None) -> BrandSchema:
        """
        Partially update a Brand by ID

        Partially update a Brand by ID
        """
        data = {
            "id": id,
            "value": value,
            "name": name,
        }
        data = {k: v for k, v in data.items() if v is not None}

        response = self.client.patch(url=f"/v3/brand/{id}/", json=data)

        response.raise_for_status()

        return BrandSchema(**response.json())

    def destroy(self, id: Optional[int] = None) -> BrandSchema:
        """
        Destroy a Brand by ID

        Destroy a Brand by ID
        """

        response = self.client.delete(url=f"/v3/brand/{id}/")

        response.raise_for_status()

        return BrandSchema(**response.json())
